// Visit QWERTZ-tek at http://qwertz.w10.site/ for my other stuff
//
// Copyright (C) 2025 T. Sosnow. <t-sosnow@posteo.com>
// This program is free software. It comes without any warranty, to
// the extent permitted by applicable law. You can redistribute it
// and/or modify it under the terms of the Do What The Fuck You Want
// To Public License, Version 2, as published by Sam Hocevar.
// See the COPYING file or http://www.wtfpl.net/ for more details.
//

#include <stdio.h> 
#include <windows.h>
#include <time.h> 

HANDLE hSerial = INVALID_HANDLE_VALUE;
DWORD dwBytesWrote = 0;
DCB dcbSerialParams = {0};
COMSTAT SerialStat ={0};

//COMMTIMEOUTS timeouts = {0};
extern void CloseSerialPort(void);

const char BA_file[] = "5BEEP\r\n10open\"COM:9N81NN\"forinputas1\r\n20TIME$=INPUT$(8,1)\r\n\
30DATE$=INPUT$(8,1)\r\n40close1\r\n50new\r\n\x01a";



int main(int argc, char *argv[])  { 
	int i;
    time_t time_of_day;
    char buffer[20]; 
  
  	printf("NEC PC-8201a TimeSync V0.1\nBy T. Sosnow. 2023-24\nType RUN\"COM:9N81NN\" in BASIC now and press Enter.\n");

	if (argc!=2){
     	printf("COM port not specified. For COM10 and higher use \\\\.\\COM-- \n");
      return 1;
	}
	
	hSerial = CreateFile(argv[1], GENERIC_READ|GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
//	hSerial = fopen(argv[1],"r");
        if (hSerial==INVALID_HANDLE_VALUE){
        		if(GetLastError()==ERROR_FILE_NOT_FOUND) {
            		printf("ERROR: %s doesn't exist.\n",argv[1]);
            		return 3;
        		}
			printf("ERROR: Can't open %s.\n",argv[0]);
			return 2;
        }

       atexit(CloseSerialPort);
       dcbSerialParams.DCBlength=sizeof(dcbSerialParams);
    if (!GetCommState(hSerial, &dcbSerialParams)) {
        printf("ERROR: Can't get %s state\n",argv[0]);
        return 4;
    }
   
   
    dcbSerialParams.BaudRate=CBR_19200;
    dcbSerialParams.ByteSize=8;
    dcbSerialParams.StopBits=ONESTOPBIT; //ONESTOPBIT, ONE5STOPBITS, TWOSTOPBITS
    dcbSerialParams.Parity=NOPARITY; //EVENPARITY, NOPARITY, ODDPARITY
    dcbSerialParams.fOutxCtsFlow=1;
    dcbSerialParams.fRtsControl=RTS_CONTROL_TOGGLE;
    dcbSerialParams.fOutX=1;
    if(!SetCommState(hSerial, &dcbSerialParams)) {
        printf("ERROR: Can't set %s state\n",argv[0]);
        return 4;
    }
    
    if(!WriteFile(hSerial, &BA_file, sizeof(BA_file), &dwBytesWrote, NULL)) {
        printf("ERROR: Couldn't write BASIC File to %s\n",argv[0]);
    }
    FlushFileBuffers(hSerial);
	while(1){
		i=GetCommModemStatus(hSerial, &dwBytesWrote);

		if(!(dwBytesWrote&MS_CTS_ON)) break;
	}

	while(1){
		GetCommModemStatus(hSerial, &dwBytesWrote);
		if(dwBytesWrote&MS_CTS_ON) break;
	}
	
   
    Sleep(50);
    time_of_day = time(NULL); 

    strftime( buffer, 20, "%T%g/%m/%d",localtime( &time_of_day ) ); 

    if(!WriteFile(hSerial, &buffer, sizeof(buffer), &dwBytesWrote, NULL)) {
        printf("ERROR: Couldn't write current Time to %s\n",argv[0]);
    }
	return 0;
}

void CloseSerialPort(){
    if (hSerial != INVALID_HANDLE_VALUE) {
    	CloseHandle(hSerial);
    }
}
